#[doc = "Register `SAR_TEMP_OFFSET` reader"]
pub struct R(crate::R<SAR_TEMP_OFFSET_SPEC>);
impl core::ops::Deref for R {
    type Target = crate::R<SAR_TEMP_OFFSET_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::convert::From<crate::R<SAR_TEMP_OFFSET_SPEC>> for R {
    fn from(reader: crate::R<SAR_TEMP_OFFSET_SPEC>) -> Self {
        R(reader)
    }
}
#[doc = "Register `SAR_TEMP_OFFSET` writer"]
pub struct W(crate::W<SAR_TEMP_OFFSET_SPEC>);
impl core::ops::Deref for W {
    type Target = crate::W<SAR_TEMP_OFFSET_SPEC>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
impl core::ops::DerefMut for W {
    #[inline(always)]
    fn deref_mut(&mut self) -> &mut Self::Target {
        &mut self.0
    }
}
impl core::convert::From<crate::W<SAR_TEMP_OFFSET_SPEC>> for W {
    fn from(writer: crate::W<SAR_TEMP_OFFSET_SPEC>) -> Self {
        W(writer)
    }
}
#[doc = "Field `TEMP_OFFSET` reader - Offset value for SAR temperature sensor in fixed point 10.6 format. Note: this field exists in products that contain SAR (m0s8sar) only."]
pub struct TEMP_OFFSET_R(crate::FieldReader<u16, u16>);
impl TEMP_OFFSET_R {
    pub(crate) fn new(bits: u16) -> Self {
        TEMP_OFFSET_R(crate::FieldReader::new(bits))
    }
}
impl core::ops::Deref for TEMP_OFFSET_R {
    type Target = crate::FieldReader<u16, u16>;
    #[inline(always)]
    fn deref(&self) -> &Self::Target {
        &self.0
    }
}
#[doc = "Field `TEMP_OFFSET` writer - Offset value for SAR temperature sensor in fixed point 10.6 format. Note: this field exists in products that contain SAR (m0s8sar) only."]
pub struct TEMP_OFFSET_W<'a> {
    w: &'a mut W,
}
impl<'a> TEMP_OFFSET_W<'a> {
    #[doc = r"Writes raw bits to the field"]
    #[inline(always)]
    pub unsafe fn bits(self, value: u16) -> &'a mut W {
        self.w.bits = (self.w.bits & !0xffff) | (value as u16 & 0xffff);
        self.w
    }
}
impl R {
    #[doc = "Bits 0:15 - Offset value for SAR temperature sensor in fixed point 10.6 format. Note: this field exists in products that contain SAR (m0s8sar) only."]
    #[inline(always)]
    pub fn temp_offset(&self) -> TEMP_OFFSET_R {
        TEMP_OFFSET_R::new((self.bits & 0xffff) as u16)
    }
}
impl W {
    #[doc = "Bits 0:15 - Offset value for SAR temperature sensor in fixed point 10.6 format. Note: this field exists in products that contain SAR (m0s8sar) only."]
    #[inline(always)]
    pub fn temp_offset(&mut self) -> TEMP_OFFSET_W {
        TEMP_OFFSET_W { w: self }
    }
    #[doc = "Writes raw bits to the register."]
    pub unsafe fn bits(&mut self, bits: u16) -> &mut Self {
        self.0.bits(bits);
        self
    }
}
#[doc = "SAR Temperature Sensor Offset\n\nThis register you can [`read`](crate::generic::Reg::read), [`write_with_zero`](crate::generic::Reg::write_with_zero), [`reset`](crate::generic::Reg::reset), [`write`](crate::generic::Reg::write), [`modify`](crate::generic::Reg::modify). See [API](https://docs.rs/svd2rust/#read--modify--write-api).\n\nFor information about available fields see [sar_temp_offset](index.html) module"]
pub struct SAR_TEMP_OFFSET_SPEC;
impl crate::RegisterSpec for SAR_TEMP_OFFSET_SPEC {
    type Ux = u16;
}
#[doc = "`read()` method returns [sar_temp_offset::R](R) reader structure"]
impl crate::Readable for SAR_TEMP_OFFSET_SPEC {
    type Reader = R;
}
#[doc = "`write(|w| ..)` method takes [sar_temp_offset::W](W) writer structure"]
impl crate::Writable for SAR_TEMP_OFFSET_SPEC {
    type Writer = W;
}
#[doc = "`reset()` method sets SAR_TEMP_OFFSET to value 0"]
impl crate::Resettable for SAR_TEMP_OFFSET_SPEC {
    #[inline(always)]
    fn reset_value() -> Self::Ux {
        0
    }
}
